<?php
function blog_revolution_gutenberg_add_image_sizes() {
	add_image_size( 'blog-revolution-large', 1000, 800, true );
	add_image_size( 'blog-revolution-normal', 800 , 800 , true);
}
add_action( 'init', 'blog_revolution_gutenberg_add_image_sizes' );
		
add_action( 'wp_enqueue_scripts', 'blog_revolution_gutenberg_scripts' );
add_action( 'enqueue_block_editor_assets', 'blog_revolution_gutenberg_scripts' );

function blog_revolution_gutenberg_scripts() {
		if ( ! function_exists( 'register_block_type' ) ) {
			return;
		}
	
		// Load WP jQuery if not included
		wp_enqueue_script('jquery');
		// Load main js script
		
		// Main
		wp_register_style( 'brg-fonts',  BRG_URL . 'assets/css/fonts.css'); 
		wp_register_style( 'brg-style',  BRG_URL . 'assets/css/style.css'); 
		wp_register_script('brg-main', BRG_URL . 'assets/js/main.js');
				
		
		if ( has_block( 'adtheme/blogrevolution' ) || is_admin()) {
			wp_enqueue_style('brg-fonts');
			wp_enqueue_style('brg-style');								
		}
		if ( has_block( 'adtheme/blogrevolution') && !is_admin() ) {
			wp_enqueue_script('brg-main');	
		}

}

function blog_revolution_box_position($settings, $id){

	if($settings['layoutStyle'] == 'style1') {

		$position_title       	 = 1;
		$position_img         	 = 2;
		$position_info        	 = 3;
		$position_content     	 = 4;		
		$position_category    	 = 5;		
		
	} elseif($settings['layoutStyle'] == 'style2') {

		$position_title       	 = 2;
		$position_img         	 = 1;
		$position_info        	 = 5;
		$position_content     	 = 4;		
		$position_category    	 = 3;		
		
	} else {

		$position_title       	 = 2;
		$position_img         	 = 1;
		$position_info        	 = 3;
		$position_content     	 = 4;		
		$position_category    	 = 5;
		
	}


	$show_title          	 = 1;
	$show_img             	 = esc_html($settings['displayFeaturedImage']);
	$show_content         	 = esc_html($settings['displayExcerpt']);
	$show_info          	 = 1;
	$show_author          	 = esc_html($settings['displayAuthor']);
	$show_date          	 = esc_html($settings['displayDate']);
	$show_comment         	 = esc_html($settings['displayComments']);
	$show_category    		 = esc_html($settings['displayCategory']);
	$number_excerpt			 = 200;
	$columns              	 = esc_html($settings['columns']);

	// Style
	$title_color			 = '';
	$text_color				 = '';
	$category_info_color	 = '';
	$hover_color			 = '';


	$general_positions = array(1,2,3,4,5);
	$return = '';
	
  foreach($general_positions as $general_position) {

			/**TITILE SECTION**/
			if($position_title == $general_position && $show_title == 1) { 
				$return .= '<h1 class="title_post"><a href="'.get_permalink().'">'.get_the_title().'</a></h1>';
			}
			/**END TITILE SECTION**/

			/**IMG SECTION**/
			if($position_img == $general_position && $show_img == 1) {
				$return .= blog_revolution_get_blogs_thumb($columns,$id);
			}
			/**END IMG SECTION**/

			/**CONTENT SECTION**/
			if($position_content == $general_position && $show_content == 1) {
					if(!is_numeric($number_excerpt)){
						$number_excerpt=200;
					}
					$return .= '<p class="text_post">';
							$excerpt = get_the_excerpt();
							$excerpt = substr($excerpt, 0, $number_excerpt);
							$result = substr($excerpt, 0, strrpos($excerpt, ' '));
							$return .= $result;
					$return .= blog_revolution_loadmore() . '</p>';
			}
			/**END CONTENT SECTION**/

			/**INFO SECTION**/
			if($position_info == $general_position && $show_info == 1) {
						$return .= '<div class="box_info line">';
							if($show_author == 1) { $return .= '<div class="info post_author"><i class="icon-user"></i>'.blog_revolution_get_author().'</div>'; }
							if($show_date == 1) { $return .= '<div class="info post_date"><i class="icon-calendar"></i>'.get_the_date().'</div>'; }
							if($show_comment == 1) { $return .= '<div class="info post_comment"><i class="icon-bubbles"></i>'.blog_revolution_comments_function($id).'</div>'; }
						$return .= '</div>';
			}
			/**END INFO SECTION**/

			/**CATEGORY SECTION**/
		  if($position_category == $general_position && $show_category == 1) { $return .= blog_revolution_category_function(); }
			/**END CATEGORY SECTION**/


  }
  return $return;
}

/**load More**/
if(!function_exists('blog_revolution_loadmore')) {
		function blog_revolution_loadmore(){
			$output = '<a href="'.get_permalink().'" class="load_more"><i class="icon-arrow-right"></i></a>';
			return $output;
		}
}

/** Get Author **/
if(!function_exists('blog_revolution_get_author')) {
	function blog_revolution_get_author() {
		$return = '<a href="'.get_author_posts_url( get_the_author_meta( 'ID' ) ).'">'.get_the_author_meta( 'display_name' ).'</a>';
		return $return;
	}
}


if(!function_exists('blog_revolution_category_function')) {
		function blog_revolution_category_function(){
			$output = '';
			$categories = get_the_category();
				if ($categories) {
					foreach($categories as $category) {
						$output .= '<h4 class="info post_category line"><a href="'.get_category_link( $category->term_id ).'">'.esc_html($category->cat_name).'</a></h4>';
					}
				}
			return $output;
		}
}


if(!function_exists('blog_revolution_comments_function')) {
	function blog_revolution_comments_function($id) {
			$args_comments = array(
					'post_id' => $id,   // Use post_id, not post_ID
					'count'   => true // Return only the count
			);
			$comments_count = get_comments( $args_comments );
			return '<a href="' . get_comments_link() .'">'.$comments_count.'</a>';
	}
}

/** Get Thumbnails **/
if(!function_exists('blog_revolution_get_thumb')) {
	function blog_revolution_get_thumb($thumbs_size = 'blog-revolution-normal') {
		global $post;
		$link = get_the_permalink();
		if(has_post_thumbnail()){
				$id_post = get_the_id();
				$single_image = wp_get_attachment_image_src( get_post_thumbnail_id($id_post), $thumbs_size );
				$image_alt = get_post_meta( get_post_thumbnail_id($id_post), '_wp_attachment_image_alt', true);
				$return = '<a  class="img_post" href="'.$link.'"><img class="blogrevolution-thumbs" src="'.$single_image[0].'" alt="'.$image_alt.'"></a>';
			} else {
				$return = '';
		}
		return $return;
	}
}

/** Get Blog Thumbnails **/
if(!function_exists('blog_revolution_get_blogs_thumb')) {
	function blog_revolution_get_blogs_thumb($columns,$post_id) {
		global $post;
		if($columns == '1') :
			$return = blog_revolution_get_thumb('blog-revolution-large');
		elseif($columns == '2') :
			$return = blog_revolution_get_thumb('blog-revolution-normal');
		else :
			$return = blog_revolution_get_thumb('blog-revolution-normal');
		endif;
		return $return;
	}
}

/** Get Numeric Pagination **/
if(!function_exists('blog_revolution_posts_numeric_pagination')) {
	function blog_revolution_posts_numeric_pagination($pages = '', $range = 2,$loop,$paged) {
		 $showitems = ($range * 2)+1;

		 if(empty($paged)) $paged = 1;

		 if($pages == '')
		 {
			 $pages = $loop->max_num_pages;
			 if(!$pages)
			 {
				 $pages = 1;
			 }
		 }

		 $return = '';

		 if(1 != $pages) {
			 $return .= "<div class='fnwp-numeric-pagination'>";
			 if($paged > 2 && $paged > $range+1 && $showitems < $pages) $return .=  "<a href='".get_pagenum_link(1)."' class=\"fnwp-pagination-numeric-arrow\"><i class=\"icon-arrow-left\"></i></a>";
			 if($paged > 1 && $showitems < $pages) $return .=  "<a href='".get_pagenum_link($paged - 1)."' class=\"fnwp-pagination-numeric-arrow\"><i class=\"icon-arrow-left2\"></i></a>";

			 for ($i=1; $i <= $pages; $i++)
			 {
				 if (1 != $pages &&( !($i >= $paged+$range+1 || $i <= $paged-$range-1) || $pages <= $showitems ))
				 {
					 $return .=  ($paged == $i)? "<span class='current'>".$i."</span>":"<a href='".get_pagenum_link($i)."' class='inactive'>".$i."</a>";
				 }
			 }

			 if ($paged < $pages && $showitems < $pages) $return .= "<a href='".get_pagenum_link($paged + 1)."' class=\"fnwp-pagination-numeric-arrow\"><i class=\"icon-arrow-right\"></i></a>";
			 if ($paged < $pages-1 &&  $paged+$range-1 < $pages && $showitems < $pages) $return .=  "<a href='".get_pagenum_link($pages)."' class=\"fnwp-pagination-numeric-arrow\"><i class=\"icon-arrow-right2\"></i></a>";
			 $return .=  "</div>\n";
		 }

		 return $return;
	}
}


if(!function_exists('blog_revolution_query')) {
	function blog_revolution_query( $source,
						$posts_source,
						$posts_type,
						$categories,
						$categories_post_type,
						$order,
						$orderby,
						$pagination,
						$pagination_type,
						$num_posts,
						$num_posts_page) {

						if($orderby == 'views') {
								$orderby = 'meta_value_num';
								$view_order = 'views';
						} else { $view_order = ''; }

						if($source == 'post_type') {
							$posts_source = 'all_posts';
						}

						if($posts_source == 'all_posts') {

							$query = 'post_type=Post&post_status=publish&ignore_sticky_posts=1&orderby='.$orderby.'&order='.$order.'';

							// CUSTOM POST TYPE
							if($source == 'post_type') {
								$query .= '&post_type='.$posts_type.'';
							}

							if($view_order == 'views') {
								$query .= '&meta_key=wpb_post_views_count';
							}

							// CATEGORIES POST TYPE
							if($categories_post_type != '' && !empty($categories_post_type) && $source == 'post_type') {
								$taxonomy_names = get_object_taxonomies( $posts_type );
								$query .= '&'.$taxonomy_names[0].'='.$categories_post_type.'';
							}

							// CATEGORIES POSTS
							if($categories != '' && $categories != 'all' && !empty($categories) && $source == 'wp_posts') {
								$query .= '&cat='.$categories.'';	
							}

							if($pagination == 'yes' || $pagination == 'load-more') {
								$query .= '&posts_per_page='.$num_posts_page.'';
							} else {
								if($num_posts == '') { $num_posts = '-1'; }
								$query .= '&posts_per_page='.$num_posts.'';
							}

							// PAGINATION
							if($pagination == 'yes' || $pagination == 'load-more') {
								if ( get_query_var('paged') ) {
									$paged = get_query_var('paged');

								} elseif ( get_query_var('page') ) {
									$paged = get_query_var('page');
								} else {
									$paged = 1;
								}
								$query .= '&paged='.$paged.'';
							}
							// #PAGINATION

						} else { // IF STICKY


							if($pagination == 'yes' || $pagination == 'load-more') {
								$num_posts = $num_posts_page;
							} else {
								if($num_posts == '') { $num_posts = '-1'; }
								$num_posts = $num_posts;
							}

							// PAGINATION

							if ( get_query_var('paged') ) {
								$paged = get_query_var('paged');
							} elseif ( get_query_var('page') ) {
								$paged = get_query_var('page');
							} else {
								$paged = 1;
							}

							// #PAGINATION

							/* STICKY POST DA FARE ARRAY PER SCRITTURA IN ARRAY */

							$sticky = get_option( 'sticky_posts' );
							$sticky = array_slice( $sticky, 0, 5 );
							if($view_order == 'views') {
								$query = array(
									'post_type' => 'post',
									'post_status' => 'publish',
									'orderby' 	=> $orderby,
									'order' => $order,
									'category_name' => $categories,
									'posts_per_page' => $num_posts,
									'meta_key' => 'wpb_post_views_count',
									'paged' => $paged,
									'post__in'  => $sticky,
									'ignore_sticky_posts' => 1
								);
							} else {
								$query = array(
									'post_type' => 'post',
									'post_status' => 'publish',
									'orderby' 	=> $orderby,
									'order' => $order,
									'category_name' => $categories,
									'posts_per_page' => $num_posts,
									'paged' => $paged,
									'post__in'  => $sticky,
									'ignore_sticky_posts' => 1
								);
							}

						} // #all_posts

						return $query;
	}
}
